module     p0_dubar_emnebarbbbar_d24h0l1
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/Wmbb/1.4/Virtual/p0
   ! _dubar_emnebarbbbar/helicity0/d24h0l1.f90
   ! generator: haggies (1.1)
   use p0_dubar_emnebarbbbar_config, only: ki
   use p0_dubar_emnebarbbbar_util, only: cond
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   public :: numerator_samurai
   public :: numerator_golem95
contains
!---#[ numerator interfaces:
   !------#[ function numerator_samurai:
   function numerator_samurai(ncut,Q_ext, mu2_ext) result(numerator)
      use precision, only: ki_sam => ki
!      use p0_dubar_emnebarbbbar_groups, only: &
!           & sign => diagram24_sign, shift => diagram24_shift
      use p0_dubar_emnebarbbbar_globalsl1, only: epspow
      use p0_dubar_emnebarbbbar_kinematics
      use p0_dubar_emnebarbbbar_abbrevd24h0
      implicit none

      integer, intent(in) :: ncut
      complex(ki_sam), dimension(4), intent(in) :: Q_ext
      complex(ki_sam), intent(in) :: mu2_ext
      complex(ki_sam) :: numerator
      complex(ki) :: d24
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14
      complex(ki) :: t15
      complex(ki) :: t16

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      real(ki), dimension(0:3) :: qshift

      qshift = -k6
      Q(1)   = cmplx(real(-Q_ext(4) - qshift(0),   ki_sam), aimag(-Q_ext(4)),   &
      &ki)
      Q(2:4) = cmplx(real(-Q_ext(1:3) - qshift(1:3), ki_sam), aimag(-Q_ext(1:3))&
      &, ki)
      d24 = 0.0_ki
      t1 = (Q(1)*spval5k1(1)-Q(2)*spval5k1(2)-Q(3)*spval5k1(3)-Q(4)*spval5k1(4))
      t2 = (Q(1)*spval6k1(1)-Q(2)*spval6k1(2)-Q(3)*spval6k1(3)-Q(4)*spval6k1(4))
      t3 = (Q(1)*spval6k2(1)-Q(2)*spval6k2(2)-Q(3)*spval6k2(3)-Q(4)*spval6k2(4))
      t4 = (Q(1)*k1(1)-Q(2)*k1(2)-Q(3)*k1(3)-Q(4)*k1(4))
      t5 = (Q(1)*l6(1)-Q(2)*l6(2)-Q(3)*l6(3)-Q(4)*l6(4))
      t6 = (Q(1)*spvak2l6(1)-Q(2)*spvak2l6(2)-Q(3)*spvak2l6(3)-Q(4)*spvak2l6(4))
      t7 = (Q(1)*spvak3k4(1)-Q(2)*spvak3k4(2)-Q(3)*spvak3k4(3)-Q(4)*spvak3k4(4))
      t8 = (Q(1)*k2(1)-Q(2)*k2(2)-Q(3)*k2(3)-Q(4)*k2(4))
      t9 = (Q(1)*spval5k2(1)-Q(2)*spval5k2(2)-Q(3)*spval5k2(3)-Q(4)*spval5k2(4))
      t10 = (Q(1)*Q(1)-Q(2)*Q(2)-Q(3)*Q(3)-Q(4)*Q(4))
      t11 = (Q(1)*l5(1)-Q(2)*l5(2)-Q(3)*l5(3)-Q(4)*l5(4))
      t12 = (Q(1)*spval5l6(1)-Q(2)*spval5l6(2)-Q(3)*spval5l6(3)-Q(4)*spval5l6(4)&
      &)
      t13 = (Q(1)*spval5k4(1)-Q(2)*spval5k4(2)-Q(3)*spval5k4(3)-Q(4)*spval5k4(4)&
      &)
      t14 = (Q(1)*spvak2k1(1)-Q(2)*spvak2k1(2)-Q(3)*spvak2k1(3)-Q(4)*spvak2k1(4)&
      &)
      t15 = (Q(1)*spval6k4(1)-Q(2)*spval6k4(2)-Q(3)*spval6k4(3)-Q(4)*spval6k4(4)&
      &)
      t16 = (Q(1)*spvak2k4(1)-Q(2)*spvak2k4(2)-Q(3)*spvak2k4(3)-Q(4)*spvak2k4(4)&
      &)
      d24 = (abb24n1+t1*abb24n10+t10*abb24n5+t11*abb24n6+t12*abb24n7+t13*abb24n8&
      &+t14*abb24n9+t2*abb24n11+t3*abb24n16+t4*abb24n2+t5*abb24n20+t6*abb24n22+t&
      &7*abb24n3+t8*abb24n42+t8*t8*abb24n37+t9*abb24n4+abb24n12*(Q(1)*spvak3k1(1&
      &)-Q(2)*spvak3k1(2)-Q(3)*spvak3k1(3)-Q(4)*spvak3k1(4))+t1*t16*abb24n51+t1*&
      &t3*abb24n47+t1*t6*abb24n48+t1*t7*abb24n13+t1*t8*abb24n45+t1*t9*abb24n46+t&
      &1*abb24n29*(Q(1)*spvak1k2(1)-Q(2)*spvak1k2(2)-Q(3)*spvak1k2(3)-Q(4)*spvak&
      &1k2(4))+t1*abb24n52*(Q(1)*spvak3k2(1)-Q(2)*spvak3k2(2)-Q(3)*spvak3k2(3)-Q&
      &(4)*spvak3k2(4))+t10*t15*abb24n18+t10*t16*abb24n24+t10*t8*abb24n31+t11*t1&
      &5*abb24n19+t11*t16*abb24n25+t11*t8*abb24n30+t12*t8*abb24n34+t13*t8*abb24n&
      &39+t14*t15*abb24n53+t14*t3*abb24n44+t14*t5*abb24n49+t14*t7*abb24n15+t15*t&
      &4*abb24n17+t15*t8*abb24n41+t16*t2*abb24n54+t16*t3*abb24n40+t16*t4*abb24n2&
      &3+t16*t8*abb24n28+t16*t9*abb24n38+t2*t6*abb24n50+t2*t7*abb24n14+t2*t8*abb&
      &24n43+t3*t6*abb24n35+t4*t8*abb24n32+t5*t8*abb24n36+t6*t9*abb24n33+t7*t8*a&
      &bb24n27+t7*abb24n21*(Q(1)*spval6l5(1)-Q(2)*spval6l5(2)-Q(3)*spval6l5(3)-Q&
      &(4)*spval6l5(4))+t7*abb24n26*(Q(1)*spvak2l5(1)-Q(2)*spvak2l5(2)-Q(3)*spva&
      &k2l5(3)-Q(4)*spvak2l5(4))+t14*t3*t7*abb24n56+t14*t7*t9*abb24n55+t2*t7*t8*&
      &abb24n57)
      numerator = cmplx(real(d24, ki), aimag(d24), ki_sam)
   end function numerator_samurai
   !------#] function numerator_samurai:
   !------#[ function numerator_golem95:
   function numerator_golem95(Q_ext, mu2_ext) result(numerator)
      use precision_golem, only: ki_gol => ki
      use p0_dubar_emnebarbbbar_globalsl1, only: epspow
      use p0_dubar_emnebarbbbar_kinematics
      use p0_dubar_emnebarbbbar_abbrevd24h0
      implicit none

      real(ki_gol), dimension(0:3), intent(in) :: Q_ext
      real(ki_gol), intent(in) :: mu2_ext
      complex(ki_gol) :: numerator
      complex(ki) :: d24
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14
      complex(ki) :: t15
      complex(ki) :: t16

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      real(ki), dimension(4) :: qshift

      qshift = -k6
      Q(:) = cmplx(real(-Q_ext(:) - qshift(:), ki_gol), 0.0_ki_gol, ki)
      d24 = 0.0_ki
      t1 = (Q(1)*spval5k1(1)-Q(2)*spval5k1(2)-Q(3)*spval5k1(3)-Q(4)*spval5k1(4))
      t2 = (Q(1)*spval6k1(1)-Q(2)*spval6k1(2)-Q(3)*spval6k1(3)-Q(4)*spval6k1(4))
      t3 = (Q(1)*spval6k2(1)-Q(2)*spval6k2(2)-Q(3)*spval6k2(3)-Q(4)*spval6k2(4))
      t4 = (Q(1)*k1(1)-Q(2)*k1(2)-Q(3)*k1(3)-Q(4)*k1(4))
      t5 = (Q(1)*l6(1)-Q(2)*l6(2)-Q(3)*l6(3)-Q(4)*l6(4))
      t6 = (Q(1)*spvak2l6(1)-Q(2)*spvak2l6(2)-Q(3)*spvak2l6(3)-Q(4)*spvak2l6(4))
      t7 = (Q(1)*spvak3k4(1)-Q(2)*spvak3k4(2)-Q(3)*spvak3k4(3)-Q(4)*spvak3k4(4))
      t8 = (Q(1)*k2(1)-Q(2)*k2(2)-Q(3)*k2(3)-Q(4)*k2(4))
      t9 = (Q(1)*spval5k2(1)-Q(2)*spval5k2(2)-Q(3)*spval5k2(3)-Q(4)*spval5k2(4))
      t10 = (Q(1)*Q(1)-Q(2)*Q(2)-Q(3)*Q(3)-Q(4)*Q(4))
      t11 = (Q(1)*l5(1)-Q(2)*l5(2)-Q(3)*l5(3)-Q(4)*l5(4))
      t12 = (Q(1)*spval5l6(1)-Q(2)*spval5l6(2)-Q(3)*spval5l6(3)-Q(4)*spval5l6(4)&
      &)
      t13 = (Q(1)*spval5k4(1)-Q(2)*spval5k4(2)-Q(3)*spval5k4(3)-Q(4)*spval5k4(4)&
      &)
      t14 = (Q(1)*spvak2k1(1)-Q(2)*spvak2k1(2)-Q(3)*spvak2k1(3)-Q(4)*spvak2k1(4)&
      &)
      t15 = (Q(1)*spval6k4(1)-Q(2)*spval6k4(2)-Q(3)*spval6k4(3)-Q(4)*spval6k4(4)&
      &)
      t16 = (Q(1)*spvak2k4(1)-Q(2)*spvak2k4(2)-Q(3)*spvak2k4(3)-Q(4)*spvak2k4(4)&
      &)
      d24 = (abb24n1+t1*abb24n10+t10*abb24n5+t11*abb24n6+t12*abb24n7+t13*abb24n8&
      &+t14*abb24n9+t2*abb24n11+t3*abb24n16+t4*abb24n2+t5*abb24n20+t6*abb24n22+t&
      &7*abb24n3+t8*abb24n42+t8*t8*abb24n37+t9*abb24n4+abb24n12*(Q(1)*spvak3k1(1&
      &)-Q(2)*spvak3k1(2)-Q(3)*spvak3k1(3)-Q(4)*spvak3k1(4))+t1*t16*abb24n51+t1*&
      &t3*abb24n47+t1*t6*abb24n48+t1*t7*abb24n13+t1*t8*abb24n45+t1*t9*abb24n46+t&
      &1*abb24n29*(Q(1)*spvak1k2(1)-Q(2)*spvak1k2(2)-Q(3)*spvak1k2(3)-Q(4)*spvak&
      &1k2(4))+t1*abb24n52*(Q(1)*spvak3k2(1)-Q(2)*spvak3k2(2)-Q(3)*spvak3k2(3)-Q&
      &(4)*spvak3k2(4))+t10*t15*abb24n18+t10*t16*abb24n24+t10*t8*abb24n31+t11*t1&
      &5*abb24n19+t11*t16*abb24n25+t11*t8*abb24n30+t12*t8*abb24n34+t13*t8*abb24n&
      &39+t14*t15*abb24n53+t14*t3*abb24n44+t14*t5*abb24n49+t14*t7*abb24n15+t15*t&
      &4*abb24n17+t15*t8*abb24n41+t16*t2*abb24n54+t16*t3*abb24n40+t16*t4*abb24n2&
      &3+t16*t8*abb24n28+t16*t9*abb24n38+t2*t6*abb24n50+t2*t7*abb24n14+t2*t8*abb&
      &24n43+t3*t6*abb24n35+t4*t8*abb24n32+t5*t8*abb24n36+t6*t9*abb24n33+t7*t8*a&
      &bb24n27+t7*abb24n21*(Q(1)*spval6l5(1)-Q(2)*spval6l5(2)-Q(3)*spval6l5(3)-Q&
      &(4)*spval6l5(4))+t7*abb24n26*(Q(1)*spvak2l5(1)-Q(2)*spvak2l5(2)-Q(3)*spva&
      &k2l5(3)-Q(4)*spvak2l5(4))+t14*t3*t7*abb24n56+t14*t7*t9*abb24n55+t2*t7*t8*&
      &abb24n57)

      numerator = cmplx(real(d24, ki), aimag(d24), ki_gol)
   end function numerator_golem95
   !------#] function numerator_golem95:
!---#] numerator interfaces:
end module p0_dubar_emnebarbbbar_d24h0l1
