module     p0_dubar_emnebarbbbar_d3h0l1d
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/Wmbb/1.4/Virtual/p0
   ! _dubar_emnebarbbbar/helicity0/d3h0l1d.f90
   ! generator: haggies (1.1)
   use p0_dubar_emnebarbbbar_config, only: ki
   use p0_dubar_emnebarbbbar_util, only: cond, d => metric_tensor
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   integer, private :: iv0
   integer, private :: iv1
   integer, private :: iv2
   integer, private :: iv3
   real(ki), dimension(4), private :: qshift


   public :: derivative, reconstruct_d3
contains

!---#[ function derivative:
   function derivative(mu2, i1, i2, i3) result(numerator)
      use p0_dubar_emnebarbbbar_globalsl1, only: epspow
      use p0_dubar_emnebarbbbar_kinematics
      use p0_dubar_emnebarbbbar_abbrevd3h0
      implicit none
      complex(ki), intent(in) :: mu2
      integer, intent(in), optional :: i1
      integer, intent(in), optional :: i2
      integer, intent(in), optional :: i3
      complex(ki) :: numerator
      complex(ki) :: loc
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14
      complex(ki) :: t15
      complex(ki) :: t16
      complex(ki) :: t17
      complex(ki) :: t18
      complex(ki) :: t19
      complex(ki) :: t20
      complex(ki) :: t21
      complex(ki) :: t22
      complex(ki) :: t23
      complex(ki) :: t24
      complex(ki) :: t25
      complex(ki) :: t26
      complex(ki) :: t27
      complex(ki) :: t28
      complex(ki) :: t29
      complex(ki) :: t30
      complex(ki) :: t31
      complex(ki) :: t32
      complex(ki) :: t33
      complex(ki) :: t34
      complex(ki) :: t35
      complex(ki) :: t36
      complex(ki) :: t37
      complex(ki) :: t38
      complex(ki) :: t39
      complex(ki) :: t40
      real(ki) :: t41
      real(ki) :: t42
      real(ki) :: t43
      real(ki) :: t44
      integer :: deg
      complex(ki), dimension(4), parameter :: Q = (/&
        &(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki)/)
      qshift = -k2
      numerator = 0.0_ki
      deg = 0
      if(present(i1)) then
         iv1 = i1
         deg = 1
      else
         iv1 = 1
      end if
      if(present(i2)) then
         iv2 = i2
         deg = 2
      else
         iv2 = 1
      end if
      if(present(i3)) then
         iv3 = i3
         deg = 3
      else
         iv3 = 1
      end if
      t41 = dotproduct(qshift, qshift)
      t42 = dotproduct(k3, qshift)
      t43 = dotproduct(k4, qshift)
      t1 = (spvak3k4(1)*qshift(1)-spvak3k4(2)*qshift(2)-spvak3k4(3)*qshift(3)-sp&
      &vak3k4(4)*qshift(4))
      t2 = (spval5k2(1)*qshift(1)-spval5k2(2)*qshift(2)-spval5k2(3)*qshift(3)-sp&
      &val5k2(4)*qshift(4))
      t3 = (spval6k2(1)*qshift(1)-spval6k2(2)*qshift(2)-spval6k2(3)*qshift(3)-sp&
      &val6k2(4)*qshift(4))
      t4 = (spval5k1(1)*qshift(1)-spval5k1(2)*qshift(2)-spval5k1(3)*qshift(3)-sp&
      &val5k1(4)*qshift(4))
      t5 = (spval6k1(1)*qshift(1)-spval6k1(2)*qshift(2)-spval6k1(3)*qshift(3)-sp&
      &val6k1(4)*qshift(4))
      t44 = dotproduct(k2, qshift)
      t6 = (spvak3k1(1)*qshift(1)-spvak3k1(2)*qshift(2)-spvak3k1(3)*qshift(3)-sp&
      &vak3k1(4)*qshift(4))
      t7 = (spvak4k1(1)*qshift(1)-spvak4k1(2)*qshift(2)-spvak4k1(3)*qshift(3)-sp&
      &vak4k1(4)*qshift(4))
      t8 = (spvak2k1(1)*qshift(1)-spvak2k1(2)*qshift(2)-spvak2k1(3)*qshift(3)-sp&
      &vak2k1(4)*qshift(4))
      t9 = (spvak2k4(1)*qshift(1)-spvak2k4(2)*qshift(2)-spvak2k4(3)*qshift(3)-sp&
      &vak2k4(4)*qshift(4))
      t10 = (spvak2k3(1)*qshift(1)-spvak2k3(2)*qshift(2)-spvak2k3(3)*qshift(3)-s&
      &pvak2k3(4)*qshift(4))
      if(deg.eq.0) then
         numerator = (abb3n37+t1*abb3n59+t2*abb3n60+t3*abb3n61+t4*abb3n62+t41*ab&
         &b3n48+t42*abb3n58+t43*abb3n58+t44*abb3n64+t5*abb3n63+t1*t10*abb3n53+t1&
         &*t4*abb3n57+t1*t41*abb3n65+t1*t44*abb3n55+t1*t5*abb3n56+t1*t6*abb3n41+&
         &t1*t7*abb3n39+t1*t9*abb3n51+t2*t44*abb3n50+t2*t8*abb3n44+t2*t9*abb3n47&
         &+t3*t44*abb3n49+t3*t8*abb3n42+t3*t9*abb3n46+t4*t41*abb3n70+t4*t42*abb3&
         &n44+t4*t43*abb3n44+t4*t44*abb3n45+t41*t5*abb3n72+t41*t6*abb3n74+t41*t9&
         &*abb3n67+t42*t5*abb3n42+t42*t6*abb3n40+t42*t9*abb3n54+t43*t5*abb3n42+t&
         &43*t6*abb3n40+t43*t9*abb3n54+t44*t5*abb3n43+t44*t6*abb3n38+t44*t9*abb3&
         &n52+t1*t2*t8*abb3n76+t1*t3*t8*abb3n77)
         return
      end if
      t11 = k2(iv1)
      t12 = k3(iv1)
      t13 = k4(iv1)
      t14 = qshift(iv1)
      t15 = spvak3k4(iv1)
      t16 = spval5k1(iv1)
      t17 = spval5k2(iv1)
      t18 = spval6k1(iv1)
      t19 = spval6k2(iv1)
      t20 = spvak2k1(iv1)
      t21 = spvak2k3(iv1)
      t22 = spvak2k4(iv1)
      t23 = t22*abb3n54
      t24 = spvak3k1(iv1)
      t25 = t24*abb3n40
      t26 = spvak4k1(iv1)
      t27 = t16*abb3n44
      t28 = t18*abb3n42
      if(deg.eq.1) then
         numerator = (t11*abb3n64+t12*abb3n58+t13*abb3n58+t14*abb3n69+t15*abb3n5&
         &9+t16*abb3n62+t17*abb3n60+t18*abb3n63+t19*abb3n61+t23*t42+t23*t43+t25*&
         &t42+t25*t43+t27*t42+t27*t43+t28*t42+t28*t43+t1*t11*abb3n55+t1*t14*abb3&
         &n66+t1*t16*abb3n57+t1*t18*abb3n56+t1*t21*abb3n53+t1*t22*abb3n51+t1*t24&
         &*abb3n41+t1*t26*abb3n39+t10*t15*abb3n53+t11*t2*abb3n50+t11*t3*abb3n49+&
         &t11*t4*abb3n45+t11*t5*abb3n43+t11*t6*abb3n38+t11*t9*abb3n52+t12*t4*abb&
         &3n44+t12*t5*abb3n42+t12*t6*abb3n40+t12*t9*abb3n54+t13*t4*abb3n44+t13*t&
         &5*abb3n42+t13*t6*abb3n40+t13*t9*abb3n54+t14*t4*abb3n71+t14*t5*abb3n73+&
         &t14*t6*abb3n75+t14*t9*abb3n68+t15*t4*abb3n57+t15*t41*abb3n65+t15*t44*a&
         &bb3n55+t15*t5*abb3n56+t15*t6*abb3n41+t15*t7*abb3n39+t15*t9*abb3n51+t16&
         &*t41*abb3n70+t16*t44*abb3n45+t17*t44*abb3n50+t17*t8*abb3n44+t17*t9*abb&
         &3n47+t18*t41*abb3n72+t18*t44*abb3n43+t19*t44*abb3n49+t19*t8*abb3n42+t1&
         &9*t9*abb3n46+t2*t20*abb3n44+t2*t22*abb3n47+t20*t3*abb3n42+t22*t3*abb3n&
         &46+t22*t41*abb3n67+t22*t44*abb3n52+t24*t41*abb3n74+t24*t44*abb3n38+t1*&
         &t17*t8*abb3n76+t1*t19*t8*abb3n77+t1*t2*t20*abb3n76+t1*t20*t3*abb3n77+t&
         &15*t2*t8*abb3n76+t15*t3*t8*abb3n77)
         return
      end if
      t41 = d(iv1,iv2)
      t7 = spvak2k4(iv2)
      t10 = spvak3k1(iv2)
      t23 = spvak3k4(iv2)
      t25 = spval5k1(iv2)
      t27 = spval5k2(iv2)
      t28 = spval6k1(iv2)
      t29 = spval6k2(iv2)
      t30 = k2(iv2)
      t31 = k3(iv2)
      t32 = k4(iv2)
      t33 = qshift(iv2)
      t34 = t20*t27
      t35 = t20*t29
      t36 = spvak2k1(iv2)
      t37 = t17*t36
      t38 = t19*t36
      t39 = t20*t23
      t40 = t15*t36
      if(deg.eq.2) then
         numerator = ((2.0_ki)*(t41*abb3n48+t1*t41*abb3n65+t4*t41*abb3n70+t41*t5&
         &*abb3n72+t41*t6*abb3n74+t41*t9*abb3n67)+t34*abb3n44+t35*abb3n42+t37*ab&
         &b3n44+t38*abb3n42+spvak2k3(iv2)*t15*abb3n53+spvak4k1(iv2)*t15*abb3n39+&
         &t1*t34*abb3n76+t1*t35*abb3n77+t1*t37*abb3n76+t1*t38*abb3n77+t10*t11*ab&
         &b3n38+t10*t12*abb3n40+t10*t13*abb3n40+t10*t14*abb3n75+t10*t15*abb3n41+&
         &t11*t23*abb3n55+t11*t25*abb3n45+t11*t27*abb3n50+t11*t28*abb3n43+t11*t2&
         &9*abb3n49+t11*t7*abb3n52+t12*t25*abb3n44+t12*t28*abb3n42+t12*t7*abb3n5&
         &4+t13*t25*abb3n44+t13*t28*abb3n42+t13*t7*abb3n54+t14*t23*abb3n66+t14*t&
         &25*abb3n71+t14*t28*abb3n73+t14*t7*abb3n68+t15*t25*abb3n57+t15*t28*abb3&
         &n56+t15*t30*abb3n55+t15*t33*abb3n66+t15*t7*abb3n51+t16*t23*abb3n57+t16&
         &*t30*abb3n45+t16*t31*abb3n44+t16*t32*abb3n44+t16*t33*abb3n71+t17*t30*a&
         &bb3n50+t17*t7*abb3n47+t18*t23*abb3n56+t18*t30*abb3n43+t18*t31*abb3n42+&
         &t18*t32*abb3n42+t18*t33*abb3n73+t19*t30*abb3n49+t19*t7*abb3n46+t2*t39*&
         &abb3n76+t2*t40*abb3n76+t21*t23*abb3n53+t22*t23*abb3n51+t22*t27*abb3n47&
         &+t22*t29*abb3n46+t22*t30*abb3n52+t22*t31*abb3n54+t22*t32*abb3n54+t22*t&
         &33*abb3n68+t23*t24*abb3n41+t23*t26*abb3n39+t24*t30*abb3n38+t24*t31*abb&
         &3n40+t24*t32*abb3n40+t24*t33*abb3n75+t3*t39*abb3n77+t3*t40*abb3n77+t15&
         &*t27*t8*abb3n76+t15*t29*t8*abb3n77+t17*t23*t8*abb3n76+t19*t23*t8*abb3n&
         &77)
         return
      end if
      t42 = d(iv2,iv3)
      t43 = d(iv1,iv3)
      t1 = spvak3k4(iv3)
      t2 = spval5k2(iv3)
      t3 = spval6k2(iv3)
      t4 = t1*t20
      t5 = t1*t36
      t6 = spvak2k1(iv3)
      t8 = t15*t6
      t6 = t23*t6
      if(deg.eq.3) then
         numerator = ((2.0_ki)*(spvak2k4(iv3)*t41*abb3n67+spvak3k1(iv3)*t41*abb3&
         &n74+spval5k1(iv3)*t41*abb3n70+spval6k1(iv3)*t41*abb3n72+t1*t41*abb3n65&
         &+t10*t43*abb3n74+t15*t42*abb3n65+t16*t42*abb3n70+t18*t42*abb3n72+t22*t&
         &42*abb3n67+t23*t43*abb3n65+t24*t42*abb3n74+t25*t43*abb3n70+t28*t43*abb&
         &3n72+t43*t7*abb3n67)+t17*t5*abb3n76+t17*t6*abb3n76+t19*t5*abb3n77+t19*&
         &t6*abb3n77+t2*t39*abb3n76+t2*t40*abb3n76+t27*t4*abb3n76+t27*t8*abb3n76&
         &+t29*t4*abb3n77+t29*t8*abb3n77+t3*t39*abb3n77+t3*t40*abb3n77)
         return
      end if
   end function derivative
!---#] function derivative:
!---#[ subroutine reconstruct_d3:
   subroutine     reconstruct_d3(coeffs)
      use p0_dubar_emnebarbbbar_groups, only: tensrec_info_group2
      implicit none
      complex(ki), parameter :: czip = (0.0_ki, 0.0_ki)
      complex(ki), parameter :: cone = (1.0_ki, 0.0_ki)

      type(tensrec_info_group2), intent(out) :: coeffs
      ! rank 3 case:
      !---[# reconstruct coeffs%coeffs_3:
      coeffs%coeffs_3%c0 = derivative(czip)
      coeffs%coeffs_3%c1(1,1) = derivative(czip,1)
      coeffs%coeffs_3%c1(1,2) = derivative(czip,1,1) / 2.0_ki
      coeffs%coeffs_3%c1(1,3) = derivative(czip,1,1,1) / 6.0_ki
      coeffs%coeffs_3%c1(2,1) = -derivative(czip,2)
      coeffs%coeffs_3%c1(2,2) = derivative(czip,2,2) / 2.0_ki
      coeffs%coeffs_3%c1(2,3) = -derivative(czip,2,2,2) / 6.0_ki
      coeffs%coeffs_3%c1(3,1) = -derivative(czip,3)
      coeffs%coeffs_3%c1(3,2) = derivative(czip,3,3) / 2.0_ki
      coeffs%coeffs_3%c1(3,3) = -derivative(czip,3,3,3) / 6.0_ki
      coeffs%coeffs_3%c1(4,1) = -derivative(czip,4)
      coeffs%coeffs_3%c1(4,2) = derivative(czip,4,4) / 2.0_ki
      coeffs%coeffs_3%c1(4,3) = -derivative(czip,4,4,4) / 6.0_ki
      coeffs%coeffs_3%c2(1,1) = -derivative(czip,1,2)
      coeffs%coeffs_3%c2(1,2) = derivative(czip,1,2,2) / 2.0_ki
      coeffs%coeffs_3%c2(1,3) = -derivative(czip,1,1,2) / 2.0_ki
      coeffs%coeffs_3%c2(2,1) = -derivative(czip,1,3)
      coeffs%coeffs_3%c2(2,2) = derivative(czip,1,3,3) / 2.0_ki
      coeffs%coeffs_3%c2(2,3) = -derivative(czip,1,1,3) / 2.0_ki
      coeffs%coeffs_3%c2(3,1) = -derivative(czip,1,4)
      coeffs%coeffs_3%c2(3,2) = derivative(czip,1,4,4) / 2.0_ki
      coeffs%coeffs_3%c2(3,3) = -derivative(czip,1,1,4) / 2.0_ki
      coeffs%coeffs_3%c2(4,1) = derivative(czip,2,3)
      coeffs%coeffs_3%c2(4,2) = -derivative(czip,2,3,3) / 2.0_ki
      coeffs%coeffs_3%c2(4,3) = -derivative(czip,2,2,3) / 2.0_ki
      coeffs%coeffs_3%c2(5,1) = derivative(czip,2,4)
      coeffs%coeffs_3%c2(5,2) = -derivative(czip,2,4,4) / 2.0_ki
      coeffs%coeffs_3%c2(5,3) = -derivative(czip,2,2,4) / 2.0_ki
      coeffs%coeffs_3%c2(6,1) = derivative(czip,3,4)
      coeffs%coeffs_3%c2(6,2) = -derivative(czip,3,4,4) / 2.0_ki
      coeffs%coeffs_3%c2(6,3) = -derivative(czip,3,3,4) / 2.0_ki
      coeffs%coeffs_3%c3(1,1) = derivative(czip,1,2,3)
      coeffs%coeffs_3%c3(2,1) = derivative(czip,1,2,4)
      coeffs%coeffs_3%c3(3,1) = derivative(czip,1,3,4)
      coeffs%coeffs_3%c3(4,1) = -derivative(czip,2,3,4)
      !---#] reconstruct coeffs%coeffs_3:
   end subroutine reconstruct_d3
!---#] subroutine reconstruct_d3:
end module p0_dubar_emnebarbbbar_d3h0l1d
