module     p0_dubar_emnebarbbbar_d25h1l1d
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/Wmbb/1.4/Virtual/p0
   ! _dubar_emnebarbbbar/helicity1/d25h1l1d.f90
   ! generator: haggies (1.1)
   use p0_dubar_emnebarbbbar_config, only: ki
   use p0_dubar_emnebarbbbar_util, only: cond, d => metric_tensor
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   integer, private :: iv0
   integer, private :: iv1
   integer, private :: iv2
   integer, private :: iv3
   real(ki), dimension(4), private :: qshift


   public :: derivative, reconstruct_d25
contains

!---#[ function derivative:
   function derivative(mu2, i1, i2, i3) result(numerator)
      use p0_dubar_emnebarbbbar_globalsl1, only: epspow
      use p0_dubar_emnebarbbbar_kinematics
      use p0_dubar_emnebarbbbar_abbrevd25h1
      implicit none
      complex(ki), intent(in) :: mu2
      integer, intent(in), optional :: i1
      integer, intent(in), optional :: i2
      integer, intent(in), optional :: i3
      complex(ki) :: numerator
      complex(ki) :: loc
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14
      complex(ki) :: t15
      complex(ki) :: t16
      complex(ki) :: t17
      complex(ki) :: t18
      complex(ki) :: t19
      complex(ki) :: t20
      complex(ki) :: t21
      complex(ki) :: t22
      complex(ki) :: t23
      complex(ki) :: t24
      complex(ki) :: t25
      complex(ki) :: t26
      complex(ki) :: t27
      real(ki) :: t28
      real(ki) :: t29
      real(ki) :: t30
      real(ki) :: t31
      integer :: deg
      complex(ki), dimension(4), parameter :: Q = (/&
        &(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki)/)
      qshift = k5
      numerator = 0.0_ki
      deg = 0
      if(present(i1)) then
         iv1 = i1
         deg = 1
      else
         iv1 = 1
      end if
      if(present(i2)) then
         iv2 = i2
         deg = 2
      else
         iv2 = 1
      end if
      if(present(i3)) then
         iv3 = i3
         deg = 3
      else
         iv3 = 1
      end if
      t28 = dotproduct(qshift, qshift)
      t29 = dotproduct(l6, qshift)
      t1 = (spvak3k4(1)*qshift(1)-spvak3k4(2)*qshift(2)-spvak3k4(3)*qshift(3)-sp&
      &vak3k4(4)*qshift(4))
      t30 = dotproduct(k2, qshift)
      t2 = (spval6k1(1)*qshift(1)-spval6k1(2)*qshift(2)-spval6k1(3)*qshift(3)-sp&
      &val6k1(4)*qshift(4))
      t31 = dotproduct(k1, qshift)
      t3 = (spvak2k1(1)*qshift(1)-spvak2k1(2)*qshift(2)-spvak2k1(3)*qshift(3)-sp&
      &vak2k1(4)*qshift(4))
      t4 = (spvak3k1(1)*qshift(1)-spvak3k1(2)*qshift(2)-spvak3k1(3)*qshift(3)-sp&
      &vak3k1(4)*qshift(4))
      t5 = (spval6k4(1)*qshift(1)-spval6k4(2)*qshift(2)-spval6k4(3)*qshift(3)-sp&
      &val6k4(4)*qshift(4))
      t6 = (spval6k2(1)*qshift(1)-spval6k2(2)*qshift(2)-spval6k2(3)*qshift(3)-sp&
      &val6k2(4)*qshift(4))
      t7 = (spval6l5(1)*qshift(1)-spval6l5(2)*qshift(2)-spval6l5(3)*qshift(3)-sp&
      &val6l5(4)*qshift(4))
      if(deg.eq.0) then
         numerator = (abb25n27+t1*abb25n54+t2*abb25n57+t28*abb25n50+t29*abb25n52&
         &+t3*abb25n62+t30*abb25n56+t31*abb25n60+t1*t2*abb25n45+t1*t3*abb25n34+t&
         &1*t30*abb25n48+t1*t31*abb25n42+t2*t28*abb25n65+t2*t29*abb25n40+t2*t3*a&
         &bb25n44+t2*t30*abb25n37+t2*t31*abb25n38+t28*t4*abb25n74+t29*t3*abb25n3&
         &0+t29*t4*abb25n31+t3*t5*abb25n35+t3*t6*abb25n36+t30*t4*abb25n28+t31*t4&
         &*abb25n33+t1*t3*t7*abb25n78)
         return
      end if
      t8 = k1(iv1)
      t9 = k2(iv1)
      t10 = l6(iv1)
      t11 = qshift(iv1)
      t12 = spvak2k1(iv1)
      t13 = spvak3k4(iv1)
      t14 = spval6k1(iv1)
      t15 = spvak3k1(iv1)
      t16 = spval6k2(iv1)
      t17 = spval6k4(iv1)
      t18 = spval6l5(iv1)
      if(deg.eq.1) then
         numerator = (t10*abb25n51+t11*abb25n53+t12*abb25n41+t13*abb25n49+t14*ab&
         &b25n46+t8*abb25n43+t9*abb25n47+t1*t12*abb25n71+t1*t14*abb25n58+t1*t8*a&
         &bb25n61+t1*t9*abb25n55+t10*t2*abb25n63+t10*t3*abb25n77+t10*t4*abb25n76&
         &+t11*t2*abb25n64+t11*t4*abb25n73+t12*t2*abb25n59+t12*t29*abb25n77+t12*&
         &t5*abb25n70+t12*t6*abb25n69+t13*t2*abb25n58+t13*t3*abb25n71+t13*t30*ab&
         &b25n55+t13*t31*abb25n61+t14*t28*abb25n39+t14*t29*abb25n63+t14*t3*abb25&
         &n59+t14*t30*abb25n68+t14*t31*abb25n67+t15*t28*abb25n32+t15*t29*abb25n7&
         &6+t15*t30*abb25n79+t15*t31*abb25n72+t16*t3*abb25n69+t17*t3*abb25n70+t2&
         &*t8*abb25n67+t2*t9*abb25n68+t4*t8*abb25n72+t4*t9*abb25n79+t1*t12*t7*ab&
         &b25n29+t1*t18*t3*abb25n29+t13*t3*t7*abb25n29)
         return
      end if
      t28 = d(iv1,iv2)
      t5 = spvak3k1(iv2)
      t6 = spvak3k4(iv2)
      t19 = spval6k1(iv2)
      t20 = k1(iv2)
      t21 = k2(iv2)
      t22 = spvak2k1(iv2)
      t23 = l6(iv2)
      t24 = qshift(iv2)
      t25 = t12*t6
      t26 = t13*t22
      t27 = spval6l5(iv2)
      if(deg.eq.2) then
         numerator = ((2.0_ki)*(t28*abb25n50+t2*t28*abb25n65+t28*t4*abb25n74)+t2&
         &5*abb25n34+t26*abb25n34+spval6k2(iv2)*t12*abb25n36+spval6k4(iv2)*t12*a&
         &bb25n35+t10*t19*abb25n40+t10*t22*abb25n30+t10*t5*abb25n31+t11*t19*abb2&
         &5n66+t11*t5*abb25n75+t12*t19*abb25n44+t12*t23*abb25n30+t13*t19*abb25n4&
         &5+t13*t20*abb25n42+t13*t21*abb25n48+t14*t20*abb25n38+t14*t21*abb25n37+&
         &t14*t22*abb25n44+t14*t23*abb25n40+t14*t24*abb25n66+t14*t6*abb25n45+t15&
         &*t20*abb25n33+t15*t21*abb25n28+t15*t23*abb25n31+t15*t24*abb25n75+t16*t&
         &22*abb25n36+t17*t22*abb25n35+t19*t8*abb25n38+t19*t9*abb25n37+t25*t7*ab&
         &b25n78+t26*t7*abb25n78+t5*t8*abb25n33+t5*t9*abb25n28+t6*t8*abb25n42+t6&
         &*t9*abb25n48+t1*t12*t27*abb25n78+t1*t18*t22*abb25n78+t13*t27*t3*abb25n&
         &78+t18*t3*t6*abb25n78)
         return
      end if
      t29 = d(iv2,iv3)
      t30 = d(iv1,iv3)
      t1 = spval6l5(iv3)
      t2 = spvak3k4(iv3)
      t3 = spvak2k1(iv3)
      if(deg.eq.3) then
         numerator = ((2.0_ki)*(spvak3k1(iv3)*t28*abb25n32+spval6k1(iv3)*t28*abb&
         &25n39+t14*t29*abb25n39+t15*t29*abb25n32+t19*t30*abb25n39+t30*t5*abb25n&
         &32)+t1*t25*abb25n29+t1*t26*abb25n29+t12*t2*t27*abb25n29+t13*t27*t3*abb&
         &25n29+t18*t2*t22*abb25n29+t18*t3*t6*abb25n29)
         return
      end if
   end function derivative
!---#] function derivative:
!---#[ subroutine reconstruct_d25:
   subroutine     reconstruct_d25(coeffs)
      use p0_dubar_emnebarbbbar_groups, only: tensrec_info_group4
      implicit none
      complex(ki), parameter :: czip = (0.0_ki, 0.0_ki)
      complex(ki), parameter :: cone = (1.0_ki, 0.0_ki)

      type(tensrec_info_group4), intent(out) :: coeffs
      ! rank 3 case:
      !---[# reconstruct coeffs%coeffs_25:
      coeffs%coeffs_25%c0 = derivative(czip)
      coeffs%coeffs_25%c1(1,1) = derivative(czip,1)
      coeffs%coeffs_25%c1(1,2) = derivative(czip,1,1) / 2.0_ki
      coeffs%coeffs_25%c1(1,3) = derivative(czip,1,1,1) / 6.0_ki
      coeffs%coeffs_25%c1(2,1) = -derivative(czip,2)
      coeffs%coeffs_25%c1(2,2) = derivative(czip,2,2) / 2.0_ki
      coeffs%coeffs_25%c1(2,3) = -derivative(czip,2,2,2) / 6.0_ki
      coeffs%coeffs_25%c1(3,1) = -derivative(czip,3)
      coeffs%coeffs_25%c1(3,2) = derivative(czip,3,3) / 2.0_ki
      coeffs%coeffs_25%c1(3,3) = -derivative(czip,3,3,3) / 6.0_ki
      coeffs%coeffs_25%c1(4,1) = -derivative(czip,4)
      coeffs%coeffs_25%c1(4,2) = derivative(czip,4,4) / 2.0_ki
      coeffs%coeffs_25%c1(4,3) = -derivative(czip,4,4,4) / 6.0_ki
      coeffs%coeffs_25%c2(1,1) = -derivative(czip,1,2)
      coeffs%coeffs_25%c2(1,2) = derivative(czip,1,2,2) / 2.0_ki
      coeffs%coeffs_25%c2(1,3) = -derivative(czip,1,1,2) / 2.0_ki
      coeffs%coeffs_25%c2(2,1) = -derivative(czip,1,3)
      coeffs%coeffs_25%c2(2,2) = derivative(czip,1,3,3) / 2.0_ki
      coeffs%coeffs_25%c2(2,3) = -derivative(czip,1,1,3) / 2.0_ki
      coeffs%coeffs_25%c2(3,1) = -derivative(czip,1,4)
      coeffs%coeffs_25%c2(3,2) = derivative(czip,1,4,4) / 2.0_ki
      coeffs%coeffs_25%c2(3,3) = -derivative(czip,1,1,4) / 2.0_ki
      coeffs%coeffs_25%c2(4,1) = derivative(czip,2,3)
      coeffs%coeffs_25%c2(4,2) = -derivative(czip,2,3,3) / 2.0_ki
      coeffs%coeffs_25%c2(4,3) = -derivative(czip,2,2,3) / 2.0_ki
      coeffs%coeffs_25%c2(5,1) = derivative(czip,2,4)
      coeffs%coeffs_25%c2(5,2) = -derivative(czip,2,4,4) / 2.0_ki
      coeffs%coeffs_25%c2(5,3) = -derivative(czip,2,2,4) / 2.0_ki
      coeffs%coeffs_25%c2(6,1) = derivative(czip,3,4)
      coeffs%coeffs_25%c2(6,2) = -derivative(czip,3,4,4) / 2.0_ki
      coeffs%coeffs_25%c2(6,3) = -derivative(czip,3,3,4) / 2.0_ki
      coeffs%coeffs_25%c3(1,1) = derivative(czip,1,2,3)
      coeffs%coeffs_25%c3(2,1) = derivative(czip,1,2,4)
      coeffs%coeffs_25%c3(3,1) = derivative(czip,1,3,4)
      coeffs%coeffs_25%c3(4,1) = -derivative(czip,2,3,4)
      !---#] reconstruct coeffs%coeffs_25:
   end subroutine reconstruct_d25
!---#] subroutine reconstruct_d25:
end module p0_dubar_emnebarbbbar_d25h1l1d
