module     p0_dubar_emnebarbbbar_abbrevd9h0
   use p0_dubar_emnebarbbbar_config, only: ki
   use p0_dubar_emnebarbbbar_globalsh0
   implicit none
   private
   complex(ki), public :: abb9n1
   complex(ki), public :: abb9n2
   complex(ki), public :: abb9n3
   complex(ki), public :: abb9n4
   complex(ki), public :: abb9n5
   complex(ki), public :: abb9n6
   complex(ki), public :: rat2d9
   complex(ki), public :: abb9n8
   complex(ki), public :: abb9n9
   complex(ki), public :: abb9n10
   complex(ki), public :: abb9n11
   complex(ki), public :: abb9n12
   complex(ki), public :: abb9n13
   complex(ki), public :: abb9n14
   complex(ki), public :: abb9n15
   complex(ki), public :: abb9n16
   complex(ki), public :: abb9n17
   complex(ki) :: t1
   complex(ki) :: t2
   complex(ki) :: t3
   complex(ki) :: t4
   complex(ki) :: t5
   complex(ki) :: t6
   complex(ki) :: t7
   complex(ki) :: t8
   complex(ki) :: t9
   complex(ki) :: t10
   complex(ki) :: t11
   complex(ki) :: t12
   complex(ki) :: t13
   complex(ki) :: t14
   complex(ki) :: t15
   complex(ki) :: t16
   complex(ki) :: t17
   complex(ki) :: t18
   complex(ki) :: t19
   complex(ki) :: t20
   complex(ki) :: t21
   complex(ki) :: t22
   complex(ki) :: t23
   complex(ki) :: t24
   complex(ki) :: t25
   complex(ki) :: t26
   complex(ki) :: t27
   complex(ki) :: t28
   complex(ki) :: t29
   complex(ki) :: t30
   complex(ki) :: t31
   complex(ki) :: t32
   complex(ki) :: t33
   complex(ki) :: t34
   complex(ki) :: t35
   complex(ki) :: t36
   complex(ki) :: t37
   complex(ki) :: t38
   complex(ki) :: t39
   real(ki) :: t40
   real(ki) :: t41
   public :: init_abbrev

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)

contains
   subroutine     init_abbrev()
      use p0_dubar_emnebarbbbar_config, only: deltaOS
      use p0_dubar_emnebarbbbar_kinematics
      use p0_dubar_emnebarbbbar_model
      use p0_dubar_emnebarbbbar_color, only: TR
      use p0_dubar_emnebarbbbar_globalsl1, only: epspow
      implicit none
      t1 = mB*c1*i_
      t2 = t1*spak2l5
      t40 = TR*TR
      t3 = t40*t2*spak3l6*spbk4k1
      t4 = (es34+es56-(es234+es12))*(es34+wW*mW*i_-mW*mW)
      t5 = es56*t4
      t6 = t3/t5
      t1 = t1*spak2l6
      t7 = t40*t1*spak3l5*spbk4k1
      t8 = t7/t5
      t41 = NC*NC
      t9 = t41*t5
      t3 = t3/t9
      t7 = t7/t9
      t10 = mB*c2*i_
      t11 = t10*spak2l5
      t4 = es56*NC*t4
      t12 = t40*t11/t4*spak3l6*spbk4k1
      t10 = t10*spak2l6
      t13 = t40*t10/t4*spak3l5*spbk4k1
      t14 = mB*NC*c2*i_
      t15 = t14*spak2l5
      t16 = t40*t15/t5*spak3l6*spbk4k1
      t14 = t14*spak2l6
      t17 = t40*t14/t5*spak3l5*spbk4k1
      t18 = t40*t2*spak3l5*spbk4k1*spbl5k2
      t19 = t5*spbl6k2
      t20 = t18/t19
      t21 = t40*t1*spak3l6*spbk4k1*spbl6k2
      t22 = t5*spbl5k2
      t23 = t21/t22
      t24 = t41*t19
      t18 = t18/t24
      t25 = t41*t22
      t21 = t21/t25
      t26 = t4*spbl6k2
      t27 = t40*t11/t26*spak3l5*spbk4k1*spbl5k2
      t28 = t4*spbl5k2
      t29 = t40*t10/t28*spak3l6*spbk4k1*spbl6k2
      t30 = t40*t15/t19*spak3l5*spbk4k1*spbl5k2
      t31 = t40*t14/t22*spak3l6*spbk4k1*spbl6k2
      abb9n1 = ((2.0_ki)*(t16+t17+t18+t21+t3+t30+t31+t7-(t8+t6+t29+t27+t23+t20+t&
      &13+t12)))
      t32 = t1*spak3k4*spbk4k1
      t33 = t40*t32
      t34 = t10*spak3k4*spbk4k1
      t35 = t14*spak3k4*spbk4k1
      t36 = t2*spak3k4*spbk4k1
      t37 = t40*t36*spbl5k2
      t38 = t11*spak3k4*spbk4k1
      t39 = t15*spak3k4*spbk4k1
      abb9n2 = ((4.0_ki)*(t37/t24+t33/t9+t40*t35/t5+t40*t39/t19*spbl5k2-(t40*t38&
      &/t26*spbl5k2+t40*t34/t4+t33/t5+t37/t19)))
      t33 = t40*t36
      t32 = t40*t32*spbl6k2
      abb9n3 = ((4.0_ki)*(t32/t25+t33/t9+t40*t39/t5+t40*t35/t22*spbl6k2-(t40*t34&
      &/t28*spbl6k2+t40*t38/t4+t33/t5+t32/t22)))
      abb9n4 = ((4.0_ki)*(t12+t13+t20+t23+t27+t29+t6+t8-(t7+t31+t30+t3+t21+t18+t&
      &17+t16)))
      t3 = t40*t1
      t6 = t40*t2*spbl5k2
      abb9n5 = ((4.0_ki)*(t6/t19+t3/t5+t40*t10/t4+t40*t11/t26*spbl5k2-(t40*t15/t&
      &19*spbl5k2+t40*t14/t5+t3/t9+t6/t24)))
      t2 = t40*t2
      t1 = t40*t1*spbl6k2
      abb9n6 = ((4.0_ki)*(t1/t22+t2/t5+t40*t11/t4+t40*t10/t28*spbl6k2-(t40*t14/t&
      &22*spbl6k2+t40*t15/t5+t2/t9+t1/t25)))
      rat2d9 = abb9n1
      rat2 = rat2 + rat2d9
      abb9n8 = -(abb9n3)
      abb9n9 = abb9n6
      abb9n10 = abb9n5
      abb9n11 = abb9n4
      abb9n12 = abb9n3
      abb9n13 = abb9n2
      abb9n14 = -(abb9n2)
      abb9n15 = (-2.0_ki)*abb9n4
      abb9n16 = -(abb9n5)
      abb9n17 = -(abb9n6)
   end subroutine
end module p0_dubar_emnebarbbbar_abbrevd9h0
