module     p0_dubar_emnebarbbbar_d25h0l1d
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/Wmbb/1.4/Virtual/p0
   ! _dubar_emnebarbbbar/helicity0/d25h0l1d.f90
   ! generator: haggies (1.1)
   use p0_dubar_emnebarbbbar_config, only: ki
   use p0_dubar_emnebarbbbar_util, only: cond, d => metric_tensor
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   integer, private :: iv0
   integer, private :: iv1
   integer, private :: iv2
   integer, private :: iv3
   real(ki), dimension(4), private :: qshift


   public :: derivative, reconstruct_d25
contains

!---#[ function derivative:
   function derivative(mu2, i1, i2, i3) result(numerator)
      use p0_dubar_emnebarbbbar_globalsl1, only: epspow
      use p0_dubar_emnebarbbbar_kinematics
      use p0_dubar_emnebarbbbar_abbrevd25h0
      implicit none
      complex(ki), intent(in) :: mu2
      integer, intent(in), optional :: i1
      integer, intent(in), optional :: i2
      integer, intent(in), optional :: i3
      complex(ki) :: numerator
      complex(ki) :: loc
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14
      complex(ki) :: t15
      complex(ki) :: t16
      complex(ki) :: t17
      complex(ki) :: t18
      complex(ki) :: t19
      complex(ki) :: t20
      complex(ki) :: t21
      complex(ki) :: t22
      complex(ki) :: t23
      complex(ki) :: t24
      complex(ki) :: t25
      complex(ki) :: t26
      complex(ki) :: t27
      complex(ki) :: t28
      complex(ki) :: t29
      complex(ki) :: t30
      complex(ki) :: t31
      complex(ki) :: t32
      complex(ki) :: t33
      real(ki) :: t34
      real(ki) :: t35
      real(ki) :: t36
      real(ki) :: t37
      integer :: deg
      complex(ki), dimension(4), parameter :: Q = (/&
        &(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki)/)
      qshift = k5
      numerator = 0.0_ki
      deg = 0
      if(present(i1)) then
         iv1 = i1
         deg = 1
      else
         iv1 = 1
      end if
      if(present(i2)) then
         iv2 = i2
         deg = 2
      else
         iv2 = 1
      end if
      if(present(i3)) then
         iv3 = i3
         deg = 3
      else
         iv3 = 1
      end if
      t1 = (spval6k1(1)*qshift(1)-spval6k1(2)*qshift(2)-spval6k1(3)*qshift(3)-sp&
      &val6k1(4)*qshift(4))
      t34 = dotproduct(qshift, qshift)
      t2 = (spvak3k4(1)*qshift(1)-spvak3k4(2)*qshift(2)-spvak3k4(3)*qshift(3)-sp&
      &vak3k4(4)*qshift(4))
      t35 = dotproduct(l6, qshift)
      t3 = (spval6k4(1)*qshift(1)-spval6k4(2)*qshift(2)-spval6k4(3)*qshift(3)-sp&
      &val6k4(4)*qshift(4))
      t36 = dotproduct(k1, qshift)
      t37 = dotproduct(k2, qshift)
      t4 = (spval6k2(1)*qshift(1)-spval6k2(2)*qshift(2)-spval6k2(3)*qshift(3)-sp&
      &val6k2(4)*qshift(4))
      t5 = (spvak2k1(1)*qshift(1)-spvak2k1(2)*qshift(2)-spvak2k1(3)*qshift(3)-sp&
      &vak2k1(4)*qshift(4))
      t6 = (spvak3k1(1)*qshift(1)-spvak3k1(2)*qshift(2)-spvak3k1(3)*qshift(3)-sp&
      &vak3k1(4)*qshift(4))
      t7 = (spvak3k2(1)*qshift(1)-spvak3k2(2)*qshift(2)-spvak3k2(3)*qshift(3)-sp&
      &vak3k2(4)*qshift(4))
      if(deg.eq.0) then
         numerator = (abb25n36+t1*abb25n107+t2*abb25n70+t3*abb25n73+t34*abb25n63&
         &+t35*abb25n72+t36*abb25n88+t37*abb25n89+t4*abb25n90+t5*abb25n99+abb25n&
         &71*(spval6l5(1)*qshift(1)-spval6l5(2)*qshift(2)-spval6l5(3)*qshift(3)-&
         &spval6l5(4)*qshift(4))+abb25n81*(spvak1k2(1)*qshift(1)-spvak1k2(2)*qsh&
         &ift(2)-spvak1k2(3)*qshift(3)-spvak1k2(4)*qshift(4))+t1*t2*abb25n39+t1*&
         &t34*abb25n94+t1*t35*abb25n51+t1*t36*abb25n49+t1*t37*abb25n48+t1*t5*abb&
         &25n61+t2*t34*abb25n75+t2*t36*abb25n62+t2*t37*abb25n64+t2*t4*abb25n52+t&
         &3*t5*abb25n38+t34*t6*abb25n102+t34*t7*abb25n84+t35*t5*abb25n42+t35*t6*&
         &abb25n43+t35*t7*abb25n59+t36*t6*abb25n45+t36*t7*abb25n57+t37*t6*abb25n&
         &41+t37*t7*abb25n56+t4*t5*abb25n47+t2*t4*t5*abb25n110)
         return
      end if
      t8 = k1(iv1)
      t9 = k2(iv1)
      t10 = l6(iv1)
      t11 = qshift(iv1)
      t12 = spvak2k1(iv1)
      t13 = spvak3k4(iv1)
      t14 = spval6k1(iv1)
      t15 = spval6k2(iv1)
      t16 = spval6k4(iv1)
      t17 = spvak3k1(iv1)
      t18 = spvak3k2(iv1)
      if(deg.eq.1) then
         numerator = (spvak1k2(iv1)*abb25n60+spval6l5(iv1)*abb25n68+t10*abb25n67&
         &+t11*abb25n78+t12*abb25n46+t13*abb25n69+t14*abb25n40+t15*abb25n53+t16*&
         &abb25n66+t8*abb25n55+t9*abb25n54+t1*t10*abb25n92+t1*t11*abb25n93+t1*t1&
         &2*abb25n80+t1*t13*abb25n108+t1*t8*abb25n96+t1*t9*abb25n97+t10*t5*abb25&
         &n105+t10*t6*abb25n104+t10*t7*abb25n82+t11*t2*abb25n74+t11*t6*abb25n101&
         &+t11*t7*abb25n83+t12*t3*abb25n109+t12*t35*abb25n105+t12*t4*abb25n98+t1&
         &3*t34*abb25n65+t13*t36*abb25n79+t13*t37*abb25n77+t13*t4*abb25n91+t14*t&
         &2*abb25n108+t14*t34*abb25n50+t14*t35*abb25n92+t14*t36*abb25n96+t14*t37&
         &*abb25n97+t14*t5*abb25n80+t15*t2*abb25n91+t15*t5*abb25n98+t16*t5*abb25&
         &n109+t17*t34*abb25n44+t17*t35*abb25n104+t17*t36*abb25n100+t17*t37*abb2&
         &5n106+t18*t34*abb25n58+t18*t35*abb25n82+t18*t36*abb25n86+t18*t37*abb25&
         &n87+t2*t8*abb25n79+t2*t9*abb25n77+t6*t8*abb25n100+t6*t9*abb25n106+t7*t&
         &8*abb25n86+t7*t9*abb25n87+t12*t2*t4*abb25n37+t13*t4*t5*abb25n37+t15*t2&
         &*t5*abb25n37)
         return
      end if
      t34 = d(iv1,iv2)
      t3 = spvak3k1(iv2)
      t19 = spvak3k2(iv2)
      t20 = spvak3k4(iv2)
      t21 = spval6k1(iv2)
      t22 = k1(iv2)
      t23 = k2(iv2)
      t24 = spvak2k1(iv2)
      t25 = l6(iv2)
      t26 = qshift(iv2)
      t27 = spval6k2(iv2)
      t28 = t12*t27
      t29 = t15*t24
      t30 = t13*t27
      t31 = t15*t20
      t32 = t12*t20
      t33 = t13*t24
      if(deg.eq.2) then
         numerator = ((2.0_ki)*(t34*abb25n63+t1*t34*abb25n94+t2*t34*abb25n75+t34&
         &*t6*abb25n102+t34*t7*abb25n84)+t28*abb25n47+t29*abb25n47+t30*abb25n52+&
         &t31*abb25n52+spval6k4(iv2)*t12*abb25n38+t10*t19*abb25n59+t10*t21*abb25&
         &n51+t10*t24*abb25n42+t10*t3*abb25n43+t11*t19*abb25n85+t11*t20*abb25n76&
         &+t11*t21*abb25n95+t11*t3*abb25n103+t12*t21*abb25n61+t12*t25*abb25n42+t&
         &13*t21*abb25n39+t13*t22*abb25n62+t13*t23*abb25n64+t13*t26*abb25n76+t14&
         &*t20*abb25n39+t14*t22*abb25n49+t14*t23*abb25n48+t14*t24*abb25n61+t14*t&
         &25*abb25n51+t14*t26*abb25n95+t16*t24*abb25n38+t17*t22*abb25n45+t17*t23&
         &*abb25n41+t17*t25*abb25n43+t17*t26*abb25n103+t18*t22*abb25n57+t18*t23*&
         &abb25n56+t18*t25*abb25n59+t18*t26*abb25n85+t19*t8*abb25n57+t19*t9*abb2&
         &5n56+t2*t28*abb25n110+t2*t29*abb25n110+t20*t8*abb25n62+t20*t9*abb25n64&
         &+t21*t8*abb25n49+t21*t9*abb25n48+t3*t8*abb25n45+t3*t9*abb25n41+t30*t5*&
         &abb25n110+t31*t5*abb25n110+t32*t4*abb25n110+t33*t4*abb25n110)
         return
      end if
      t35 = d(iv2,iv3)
      t36 = d(iv1,iv3)
      t1 = spvak3k4(iv3)
      t2 = spval6k2(iv3)
      t4 = spvak2k1(iv3)
      if(deg.eq.3) then
         numerator = ((2.0_ki)*(spvak3k1(iv3)*t34*abb25n44+spvak3k2(iv3)*t34*abb&
         &25n58+spval6k1(iv3)*t34*abb25n50+t1*t34*abb25n65+t13*t35*abb25n65+t14*&
         &t35*abb25n50+t17*t35*abb25n44+t18*t35*abb25n58+t19*t36*abb25n58+t20*t3&
         &6*abb25n65+t21*t36*abb25n50+t3*t36*abb25n44)+t2*t32*abb25n37+t2*t33*ab&
         &b25n37+t1*t12*t27*abb25n37+t1*t15*t24*abb25n37+t13*t27*t4*abb25n37+t15&
         &*t20*t4*abb25n37)
         return
      end if
   end function derivative
!---#] function derivative:
!---#[ subroutine reconstruct_d25:
   subroutine     reconstruct_d25(coeffs)
      use p0_dubar_emnebarbbbar_groups, only: tensrec_info_group4
      implicit none
      complex(ki), parameter :: czip = (0.0_ki, 0.0_ki)
      complex(ki), parameter :: cone = (1.0_ki, 0.0_ki)

      type(tensrec_info_group4), intent(out) :: coeffs
      ! rank 3 case:
      !---[# reconstruct coeffs%coeffs_25:
      coeffs%coeffs_25%c0 = derivative(czip)
      coeffs%coeffs_25%c1(1,1) = derivative(czip,1)
      coeffs%coeffs_25%c1(1,2) = derivative(czip,1,1) / 2.0_ki
      coeffs%coeffs_25%c1(1,3) = derivative(czip,1,1,1) / 6.0_ki
      coeffs%coeffs_25%c1(2,1) = -derivative(czip,2)
      coeffs%coeffs_25%c1(2,2) = derivative(czip,2,2) / 2.0_ki
      coeffs%coeffs_25%c1(2,3) = -derivative(czip,2,2,2) / 6.0_ki
      coeffs%coeffs_25%c1(3,1) = -derivative(czip,3)
      coeffs%coeffs_25%c1(3,2) = derivative(czip,3,3) / 2.0_ki
      coeffs%coeffs_25%c1(3,3) = -derivative(czip,3,3,3) / 6.0_ki
      coeffs%coeffs_25%c1(4,1) = -derivative(czip,4)
      coeffs%coeffs_25%c1(4,2) = derivative(czip,4,4) / 2.0_ki
      coeffs%coeffs_25%c1(4,3) = -derivative(czip,4,4,4) / 6.0_ki
      coeffs%coeffs_25%c2(1,1) = -derivative(czip,1,2)
      coeffs%coeffs_25%c2(1,2) = derivative(czip,1,2,2) / 2.0_ki
      coeffs%coeffs_25%c2(1,3) = -derivative(czip,1,1,2) / 2.0_ki
      coeffs%coeffs_25%c2(2,1) = -derivative(czip,1,3)
      coeffs%coeffs_25%c2(2,2) = derivative(czip,1,3,3) / 2.0_ki
      coeffs%coeffs_25%c2(2,3) = -derivative(czip,1,1,3) / 2.0_ki
      coeffs%coeffs_25%c2(3,1) = -derivative(czip,1,4)
      coeffs%coeffs_25%c2(3,2) = derivative(czip,1,4,4) / 2.0_ki
      coeffs%coeffs_25%c2(3,3) = -derivative(czip,1,1,4) / 2.0_ki
      coeffs%coeffs_25%c2(4,1) = derivative(czip,2,3)
      coeffs%coeffs_25%c2(4,2) = -derivative(czip,2,3,3) / 2.0_ki
      coeffs%coeffs_25%c2(4,3) = -derivative(czip,2,2,3) / 2.0_ki
      coeffs%coeffs_25%c2(5,1) = derivative(czip,2,4)
      coeffs%coeffs_25%c2(5,2) = -derivative(czip,2,4,4) / 2.0_ki
      coeffs%coeffs_25%c2(5,3) = -derivative(czip,2,2,4) / 2.0_ki
      coeffs%coeffs_25%c2(6,1) = derivative(czip,3,4)
      coeffs%coeffs_25%c2(6,2) = -derivative(czip,3,4,4) / 2.0_ki
      coeffs%coeffs_25%c2(6,3) = -derivative(czip,3,3,4) / 2.0_ki
      coeffs%coeffs_25%c3(1,1) = derivative(czip,1,2,3)
      coeffs%coeffs_25%c3(2,1) = derivative(czip,1,2,4)
      coeffs%coeffs_25%c3(3,1) = derivative(czip,1,3,4)
      coeffs%coeffs_25%c3(4,1) = -derivative(czip,2,3,4)
      !---#] reconstruct coeffs%coeffs_25:
   end subroutine reconstruct_d25
!---#] subroutine reconstruct_d25:
end module p0_dubar_emnebarbbbar_d25h0l1d
