module     p0_dubar_emnebarbbbar_d6h1l1d
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/Wmbb/1.4/Virtual/p0
   ! _dubar_emnebarbbbar/helicity1/d6h1l1d.f90
   ! generator: haggies (1.1)
   use p0_dubar_emnebarbbbar_config, only: ki
   use p0_dubar_emnebarbbbar_util, only: cond, d => metric_tensor
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   integer, private :: iv0
   integer, private :: iv1
   integer, private :: iv2
   real(ki), dimension(4), private :: qshift


   public :: derivative, reconstruct_d6
contains

!---#[ function derivative:
   function derivative(mu2, i1, i2) result(numerator)
      use p0_dubar_emnebarbbbar_globalsl1, only: epspow
      use p0_dubar_emnebarbbbar_kinematics
      use p0_dubar_emnebarbbbar_abbrevd6h1
      implicit none
      complex(ki), intent(in) :: mu2
      integer, intent(in), optional :: i1
      integer, intent(in), optional :: i2
      complex(ki) :: numerator
      complex(ki) :: loc
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      real(ki) :: t9
      integer :: deg
      complex(ki), dimension(4), parameter :: Q = (/&
        &(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki)/)
      qshift = -k6-k5
      numerator = 0.0_ki
      deg = 0
      if(present(i1)) then
         iv1 = i1
         deg = 1
      else
         iv1 = 1
      end if
      if(present(i2)) then
         iv2 = i2
         deg = 2
      else
         iv2 = 1
      end if
      t1 = (spval6l5(1)*qshift(1)-spval6l5(2)*qshift(2)-spval6l5(3)*qshift(3)-sp&
      &val6l5(4)*qshift(4))
      t9 = dotproduct(k2, qshift)
      t2 = (spvak2k1(1)*qshift(1)-spvak2k1(2)*qshift(2)-spvak2k1(3)*qshift(3)-sp&
      &vak2k1(4)*qshift(4))
      t3 = (spvak3k1(1)*qshift(1)-spvak3k1(2)*qshift(2)-spvak3k1(3)*qshift(3)-sp&
      &vak3k1(4)*qshift(4))
      if(deg.eq.0) then
         numerator = (abb6n20+t1*abb6n27+t2*abb6n37+t9*abb6n31+abb6n25*dotproduc&
         &t(qshift, qshift)+abb6n26*dotproduct(k1, qshift)+abb6n26*dotproduct(l5&
         &, qshift)+abb6n26*dotproduct(l6, qshift)+abb6n28*(spvak2l6(1)*qshift(1&
         &)-spvak2l6(2)*qshift(2)-spvak2l6(3)*qshift(3)-spvak2l6(4)*qshift(4))+a&
         &bb6n29*(spvak3l6(1)*qshift(1)-spvak3l6(2)*qshift(2)-spvak3l6(3)*qshift&
         &(3)-spvak3l6(4)*qshift(4))+abb6n30*(spvak2l5(1)*qshift(1)-spvak2l5(2)*&
         &qshift(2)-spvak2l5(3)*qshift(3)-spvak2l5(4)*qshift(4))+abb6n33*(spvak3&
         &l5(1)*qshift(1)-spvak3l5(2)*qshift(2)-spvak3l5(3)*qshift(3)-spvak3l5(4&
         &)*qshift(4))+abb6n34*(spvak3k2(1)*qshift(1)-spvak3k2(2)*qshift(2)-spva&
         &k3k2(3)*qshift(3)-spvak3k2(4)*qshift(4))+abb6n35*(spval6k1(1)*qshift(1&
         &)-spval6k1(2)*qshift(2)-spval6k1(3)*qshift(3)-spval6k1(4)*qshift(4))+a&
         &bb6n36*(spval5k1(1)*qshift(1)-spval5k1(2)*qshift(2)-spval5k1(3)*qshift&
         &(3)-spval5k1(4)*qshift(4))+t1*t2*abb6n24+t1*t3*abb6n22+t2*t9*abb6n23+t&
         &3*t9*abb6n21)
         return
      end if
      t4 = k2(iv1)
      t5 = spvak2k1(iv1)
      t6 = spval6l5(iv1)
      t7 = spvak3k1(iv1)
      if(deg.eq.1) then
         numerator = (k1(iv1)*abb6n26+l5(iv1)*abb6n26+l6(iv1)*abb6n26+qshift(iv1&
         &)*abb6n32+spvak2l5(iv1)*abb6n30+spvak2l6(iv1)*abb6n28+spvak3k2(iv1)*ab&
         &b6n34+spvak3l5(iv1)*abb6n33+spvak3l6(iv1)*abb6n29+spval5k1(iv1)*abb6n3&
         &6+spval6k1(iv1)*abb6n35+t4*abb6n31+t5*abb6n37+t6*abb6n27+t1*t5*abb6n24&
         &+t1*t7*abb6n22+t2*t4*abb6n23+t2*t6*abb6n24+t3*t4*abb6n21+t3*t6*abb6n22&
         &+t5*t9*abb6n23+t7*t9*abb6n21)
         return
      end if
      t1 = spvak2k1(iv2)
      t2 = spvak3k1(iv2)
      t3 = k2(iv2)
      t8 = spval6l5(iv2)
      if(deg.eq.2) then
         numerator = ((2.0_ki)*d(iv1,iv2)*abb6n25+t1*t4*abb6n23+t1*t6*abb6n24+t2&
         &*t4*abb6n21+t2*t6*abb6n22+t3*t5*abb6n23+t3*t7*abb6n21+t5*t8*abb6n24+t7&
         &*t8*abb6n22)
         return
      end if
   end function derivative
!---#] function derivative:
!---#[ subroutine reconstruct_d6:
   subroutine     reconstruct_d6(coeffs)
      use p0_dubar_emnebarbbbar_groups, only: tensrec_info_group5
      implicit none
      complex(ki), parameter :: czip = (0.0_ki, 0.0_ki)
      complex(ki), parameter :: cone = (1.0_ki, 0.0_ki)

      type(tensrec_info_group5), intent(out) :: coeffs
      ! rank 2 case:
      !---[# reconstruct coeffs%coeffs_6:
      coeffs%coeffs_6%c0 = derivative(czip)
      coeffs%coeffs_6%c1(1,1) = derivative(czip,1)
      coeffs%coeffs_6%c1(1,2) = derivative(czip,1,1) / 2.0_ki
      coeffs%coeffs_6%c1(2,1) = -derivative(czip,2)
      coeffs%coeffs_6%c1(2,2) = derivative(czip,2,2) / 2.0_ki
      coeffs%coeffs_6%c1(3,1) = -derivative(czip,3)
      coeffs%coeffs_6%c1(3,2) = derivative(czip,3,3) / 2.0_ki
      coeffs%coeffs_6%c1(4,1) = -derivative(czip,4)
      coeffs%coeffs_6%c1(4,2) = derivative(czip,4,4) / 2.0_ki
      coeffs%coeffs_6%c2(1,1) = -derivative(czip,1,2)
      coeffs%coeffs_6%c2(2,1) = -derivative(czip,1,3)
      coeffs%coeffs_6%c2(3,1) = -derivative(czip,1,4)
      coeffs%coeffs_6%c2(4,1) = derivative(czip,2,3)
      coeffs%coeffs_6%c2(5,1) = derivative(czip,2,4)
      coeffs%coeffs_6%c2(6,1) = derivative(czip,3,4)
      !---#] reconstruct coeffs%coeffs_6:
   end subroutine reconstruct_d6
!---#] subroutine reconstruct_d6:
end module p0_dubar_emnebarbbbar_d6h1l1d
