module     p0_dubar_emnebarbbbar_abbrevd25h3
   use p0_dubar_emnebarbbbar_config, only: ki
   use p0_dubar_emnebarbbbar_globalsh3
   implicit none
   private
   complex(ki), public :: abb25n1
   complex(ki), public :: abb25n2
   complex(ki), public :: abb25n3
   complex(ki), public :: abb25n4
   complex(ki), public :: abb25n5
   complex(ki), public :: abb25n6
   complex(ki), public :: abb25n7
   complex(ki), public :: abb25n8
   complex(ki), public :: abb25n9
   complex(ki), public :: abb25n10
   complex(ki), public :: abb25n11
   complex(ki), public :: abb25n12
   complex(ki), public :: abb25n13
   complex(ki), public :: abb25n14
   complex(ki), public :: abb25n15
   complex(ki), public :: abb25n16
   complex(ki), public :: abb25n17
   complex(ki), public :: rat2d25
   complex(ki), public :: abb25n19
   complex(ki), public :: abb25n20
   complex(ki), public :: abb25n21
   complex(ki), public :: abb25n22
   complex(ki), public :: abb25n23
   complex(ki), public :: abb25n24
   complex(ki), public :: abb25n25
   complex(ki), public :: abb25n26
   complex(ki), public :: abb25n27
   complex(ki), public :: abb25n28
   complex(ki), public :: abb25n29
   complex(ki), public :: abb25n30
   complex(ki), public :: abb25n31
   complex(ki), public :: abb25n32
   complex(ki), public :: abb25n33
   complex(ki), public :: abb25n34
   complex(ki), public :: abb25n35
   complex(ki), public :: abb25n36
   complex(ki), public :: abb25n37
   complex(ki), public :: abb25n38
   complex(ki), public :: abb25n39
   complex(ki), public :: abb25n40
   complex(ki), public :: abb25n41
   complex(ki), public :: abb25n42
   complex(ki), public :: abb25n43
   complex(ki), public :: abb25n44
   complex(ki), public :: abb25n45
   complex(ki), public :: abb25n46
   complex(ki), public :: abb25n47
   complex(ki), public :: abb25n48
   complex(ki), public :: abb25n49
   complex(ki), public :: abb25n50
   complex(ki), public :: abb25n51
   complex(ki), public :: abb25n52
   complex(ki), public :: abb25n53
   complex(ki) :: t1
   complex(ki) :: t2
   complex(ki) :: t3
   complex(ki) :: t4
   complex(ki) :: t5
   complex(ki) :: t6
   complex(ki) :: t7
   complex(ki) :: t8
   complex(ki) :: t9
   complex(ki) :: t10
   complex(ki) :: t11
   complex(ki) :: t12
   complex(ki) :: t13
   complex(ki) :: t14
   complex(ki) :: t15
   complex(ki) :: t16
   complex(ki) :: t17
   complex(ki) :: t18
   complex(ki) :: t19
   complex(ki) :: t20
   complex(ki) :: t21
   complex(ki) :: t22
   complex(ki) :: t23
   complex(ki) :: t24
   complex(ki) :: t25
   complex(ki) :: t26
   complex(ki) :: t27
   complex(ki) :: t28
   complex(ki) :: t29
   complex(ki) :: t30
   complex(ki) :: t31
   complex(ki) :: t32
   complex(ki) :: t33
   real(ki) :: t34
   real(ki) :: t35
   real(ki) :: t36
   public :: init_abbrev

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)

contains
   subroutine     init_abbrev()
      use p0_dubar_emnebarbbbar_config, only: deltaOS
      use p0_dubar_emnebarbbbar_kinematics
      use p0_dubar_emnebarbbbar_model
      use p0_dubar_emnebarbbbar_color, only: TR
      use p0_dubar_emnebarbbbar_globalsl1, only: epspow
      implicit none
      t1 = es34+wW*mW*i_-mW*mW
      t2 = sqrt((mB*mB))
      t3 = t2*c2*i_
      t4 = t3*spak1k2
      t5 = t4*spak2k3*spbk4k1
      t34 = TR*TR
      t6 = NC*t1
      t7 = t3*spak2k3
      t8 = t7*spak2l6
      t35 = TR*mB
      t35 = t35*t35
      t9 = t6*spak2l5
      t2 = t2*c1*i_
      t10 = t2*spak1k2
      t11 = t10*spak2k3*spbk4k1
      t12 = t34*t11*spbl5k2*spbl6k1
      t13 = t2*spak2k3
      t14 = t13*spak2l6
      t15 = t34*t14*spbl5k2*spbl6k1*spbl6k4
      t36 = NC*NC
      t16 = t36*t1
      t11 = t35*t11*spbl6k1
      t17 = t1*spak2l5
      t14 = t35*t14*spbl6k1*spbl6k4
      t18 = t36*t17
      abb25n1 = ((8.0_ki)*(t34*t5/t6*spbl5k2*spbl6k1+t35*t8/t9*spbl6k1*spbl6k4-(&
      &t34/t6*t8*spbl5k2*spbl6k1*spbl6k4+t35*t5/t9*spbl6k1))+(4.0_ki)*(t15/t1+t1&
      &1/t17+t11/t18+t15/t16-(t14/t18+t14/t17+t12/t16+t12/t1)))
      t5 = t34*t2*spbl5k1
      abb25n2 = ((4.0_ki)*(t5/t1+t5/t16-t34*(2.0_ki)*t3/t6*spbl5k1))
      t5 = t13*spbl5k4
      t8 = t5*spbl6k1
      t11 = t34*t8
      t12 = t11/t1
      t11 = t11/t16
      t14 = t7*spbl5k4
      t15 = t14*spbl6k1
      t19 = t34*(2.0_ki)*t15/t6
      t20 = t11+t12-t19
      abb25n3 = ((8.0_ki)*t20)
      abb25n4 = ((4.0_ki)*t20)
      abb25n5 = ((8.0_ki)*(t19-(t12+t11)))
      t8 = t35*t8
      t11 = t1*spak2l6
      t12 = t11*spbl6k2
      t19 = t36*t12
      t20 = t6*spak2l6
      t21 = t20*spbl6k2
      abb25n6 = ((8.0_ki)*(t35*(2.0_ki)*t15/t21-(t8/t19+t8/t12)))
      t8 = t34*t10*spbl5k1*spbl6k1
      t10 = t34*t2*spak2l6*spbl6k1*spbl6l5
      abb25n7 = ((8.0_ki)*(t34*t3/t6*spak2l6*spbl6k1*spbl6l5-t34*t4/t6*spbl5k1*s&
      &pbl6k1)+(4.0_ki)*(t8/t1+t8/t16-(t10/t16+t10/t1)))
      t4 = t7*spbk4k1
      t8 = t13*spbk4k1
      t10 = t34*t8*spbl5k2
      t15 = t34*t2*spak3l6*spbl5k4*spbl6k1
      t8 = t35*t8
      t22 = t35*t13*spbk2k1*spbl5k4
      abb25n8 = ((8.0_ki)*(t34*t4/t6*spbl5k2+t34*t3/t6*spak3l6*spbl5k4*spbl6k1-(&
      &t35/t21*t7*spbk2k1*spbl5k4+t35*t4/t9))+(4.0_ki)*(t22/t12+t8/t17+t8/t18+t2&
      &2/t19-(t15/t16+t10/t16+t15/t1+t10/t1)))
      t4 = mB*c1*i_
      t8 = t34*t4*spak1k3*spbl5k4
      t10 = t36*t11
      t12 = mB*c2*i_
      abb25n9 = ((4.0_ki)*(t8/t10+t8/t11-t34*(2.0_ki)*t12/t20*spak1k3*spbl5k4))
      t8 = t4*spak2k3
      t15 = t34*t8*spbl5k4
      t19 = t15/t11
      t15 = t15/t10
      t21 = t12*spak2k3
      t22 = t34*(2.0_ki)/t20*t21*spbl5k4
      abb25n10 = ((8.0_ki)*(t15+t19-t22))
      t15 = t22-(t19+t15)
      abb25n11 = ((4.0_ki)*t15)
      abb25n12 = ((8.0_ki)*t15)
      t15 = t21*spbl5k2
      t19 = t12*spak1k2
      t22 = t19*spak2k3*spbk4k1
      t23 = t9*spak2l6
      t24 = t34*t2*spak1k3*spbl5k4*spbl6k1
      t25 = t34*t13*spbl5k2*spbl6k4
      t26 = t8*spbl5k2
      t27 = t34*t26*spbl6k4
      t28 = t35*t8*spbl6k4
      t13 = t35*t13*spbl6k4
      t5 = t35*t5
      t29 = t4*spak1k2
      t30 = t29*spak2k3*spbk4k1
      t31 = t34*t30*spbl5k2
      t30 = t35*t30
      t32 = t17*spak2l6
      t33 = t36*t32
      abb25n13 = ((8.0_ki)*(t35*t22/t23+t34*t15/t6*spbl6k4+t34/t6*t7*spbl5k2*spb&
      &l6k4+t34*t3/t6*spak1k3*spbl5k4*spbl6k1-(t35*t7/t9*spbl6k4+t35*t21/t9*spbl&
      &6k4+t34*t22/t20*spbl5k2+t35*t14/t20))+(4.0_ki)*(t31/t10+t5/t10+t31/t11+t5&
      &/t11+t13/t17+t13/t18+t28/t17+t28/t18-(t30/t33+t30/t32+t27/t16+t25/t16+t24&
      &/t16+t27/t1+t25/t1+t24/t1)))
      t5 = t34*t26
      t7 = t35*t8
      abb25n14 = ((8.0_ki)*(t35*t21/t23-t34*t15/t20)+(4.0_ki)*(t5/t10+t5/t11-(t7&
      &/t33+t7/t32)))
      t2 = t34*t2*spbl6l5
      t5 = t34*t4*spbl6l5
      t7 = t34*t29*spbl5k1
      abb25n15 = ((8.0_ki)*(t34*t19/t20*spbl5k1-(t34*t3/t6*spbl6l5+t34*t12/t6*sp&
      &bl6l5))+(4.0_ki)*(t2/t1+t5/t1+t2/t16+t5/t16-(t7/t11+t7/t10)))
      t1 = t34*t4*spak3l6*spbl5k4
      abb25n16 = ((4.0_ki)*(t1/t10+t1/t11-t34*(2.0_ki)*t12/t20*spak3l6*spbl5k4))
      t1 = t34*t4
      abb25n17 = ((4.0_ki)*(t34*(2.0_ki)*t12/t20-(t1/t11+t1/t10)))
      rat2d25 = 0
      rat2 = rat2 + rat2d25
      abb25n19 = abb25n1
      abb25n20 = abb25n17
      abb25n21 = abb25n16
      abb25n22 = abb25n15
      abb25n23 = abb25n14
      abb25n24 = abb25n13
      abb25n25 = abb25n12
      abb25n26 = abb25n11
      abb25n27 = abb25n10
      abb25n28 = abb25n9
      abb25n29 = abb25n8
      abb25n30 = abb25n7
      abb25n31 = abb25n6
      abb25n32 = abb25n5
      abb25n33 = abb25n4
      abb25n34 = abb25n3
      abb25n35 = abb25n2
      abb25n36 = -(abb25n2)
      abb25n37 = -(abb25n3)
      abb25n38 = (-2.0_ki)*abb25n4
      abb25n39 = -(abb25n5)
      abb25n40 = -(abb25n6)
      abb25n41 = -(abb25n7)
      abb25n42 = -(abb25n8)
      abb25n43 = (-2.0_ki)*abb25n9
      abb25n44 = -(abb25n10)
      t1 = (2.0_ki)*abb25n11
      abb25n45 = t1
      abb25n46 = -(abb25n11)
      abb25n47 = -(t1)
      abb25n48 = -(abb25n12)
      abb25n49 = -(abb25n13)
      abb25n50 = -(abb25n14)
      abb25n51 = -(abb25n15)
      abb25n52 = -(abb25n16)
      abb25n53 = -(abb25n17)
   end subroutine
end module p0_dubar_emnebarbbbar_abbrevd25h3
