module     p0_dubar_emnebarbbbar_abbrevd4h3
   use p0_dubar_emnebarbbbar_config, only: ki
   use p0_dubar_emnebarbbbar_globalsh3
   implicit none
   private
   complex(ki), public :: abb4n1
   complex(ki), public :: abb4n2
   complex(ki), public :: abb4n3
   complex(ki), public :: abb4n4
   complex(ki), public :: abb4n5
   complex(ki), public :: abb4n6
   complex(ki), public :: abb4n7
   complex(ki), public :: abb4n8
   complex(ki), public :: abb4n9
   complex(ki), public :: abb4n10
   complex(ki), public :: abb4n11
   complex(ki), public :: abb4n12
   complex(ki), public :: abb4n13
   complex(ki), public :: abb4n14
   complex(ki), public :: rat2d4
   complex(ki), public :: abb4n16
   complex(ki), public :: abb4n17
   complex(ki), public :: abb4n18
   complex(ki), public :: abb4n19
   complex(ki), public :: abb4n20
   complex(ki), public :: abb4n21
   complex(ki), public :: abb4n22
   complex(ki), public :: abb4n23
   complex(ki), public :: abb4n24
   complex(ki), public :: abb4n25
   complex(ki), public :: abb4n26
   complex(ki), public :: abb4n27
   complex(ki), public :: abb4n28
   complex(ki), public :: abb4n29
   complex(ki) :: t1
   complex(ki) :: t2
   complex(ki) :: t3
   complex(ki) :: t4
   complex(ki) :: t5
   complex(ki) :: t6
   complex(ki) :: t7
   complex(ki) :: t8
   complex(ki) :: t9
   complex(ki) :: t10
   complex(ki) :: t11
   complex(ki) :: t12
   complex(ki) :: t13
   complex(ki) :: t14
   complex(ki) :: t15
   complex(ki) :: t16
   complex(ki) :: t17
   complex(ki) :: t18
   complex(ki) :: t19
   complex(ki) :: t20
   complex(ki) :: t21
   real(ki) :: t22
   real(ki) :: t23
   public :: init_abbrev

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)

contains
   subroutine     init_abbrev()
      use p0_dubar_emnebarbbbar_config, only: deltaOS
      use p0_dubar_emnebarbbbar_kinematics
      use p0_dubar_emnebarbbbar_model
      use p0_dubar_emnebarbbbar_color, only: TR
      use p0_dubar_emnebarbbbar_globalsl1, only: epspow
      implicit none
      t1 = mB*c1*i_
      t2 = t1*spak1k3
      t3 = t2*spbk4k1
      t22 = TR*TR
      t4 = (es34+es56-(es234+es12))*(es34+wW*mW*i_-mW*mW)
      t5 = es56*t4
      t6 = t1*spak3k4*spbk4k1
      t7 = mB*NC*c2*i_
      t8 = t7*spak1k3
      t9 = t8*spbk4k1
      t10 = t7*spak3k4*spbk4k1
      t11 = t5*spak2l5
      abb4n1 = ((4.0_ki)*(t22*t3/t5*spbl5k1+t22/t5*t6*spbl5k4+t22*t2/t11*spak2l6&
      &*spbk4k1*spbl6k1+t22*t1/t11*spak2l6*spak3k4*spbk4k1*spbl6k4-(t22/t11*t7*s&
      &pak2l6*spak3k4*spbk4k1*spbl6k4+t22/t11*t8*spak2l6*spbk4k1*spbl6k1+t22/t5*&
      &t9*spbl5k1+t22*t10/t5*spbl5k4)))
      t12 = t5*spak2l6
      abb4n2 = ((4.0_ki)*(t22*t3/t5*spbl6k1+t22/t5*t6*spbl6k4+t22*t2/t12*spak2l5&
      &*spbk4k1*spbl5k1+t22*t1/t12*spak2l5*spak3k4*spbk4k1*spbl5k4-(t22/t12*t7*s&
      &pak2l5*spak3k4*spbk4k1*spbl5k4+t22/t12*t8*spak2l5*spbk4k1*spbl5k1+t22/t5*&
      &t9*spbl6k1+t22*t10/t5*spbl6k4)))
      t2 = t22*t3
      t23 = NC*NC
      t3 = t23*t12
      t5 = mB*c2*i_
      t8 = t22*t5*spak1k3*spbk4k1
      t4 = es56*NC*t4
      t13 = t4*spak2l6
      t9 = t22*t9
      abb4n3 = ((4.0_ki)*(t2/t12+t2/t3-(t8/t13+t9/t12)))
      t14 = t23*t11
      t4 = t4*spak2l5
      abb4n4 = ((4.0_ki)*(t2/t11+t2/t14-(t8/t4+t9/t11)))
      t2 = t1*spak2k3
      t8 = t22*t2*spbk4k1
      t9 = t8/t12
      t15 = t8/t3
      t16 = t5*spak2k3
      t17 = t22*t16*spbk4k1
      t18 = t17/t13
      t19 = t7*spak2k3
      t20 = t22*t19*spbk4k1
      t21 = t20/t12
      abb4n5 = ((16.0_ki)*(t15+t9-(t21+t18)))
      abb4n6 = ((16.0_ki)*(t18+t21-(t9+t15)))
      t9 = t8/t11
      t8 = t8/t14
      t15 = t17/t4
      t17 = t20/t11
      abb4n7 = ((16.0_ki)*(t8+t9-(t17+t15)))
      abb4n8 = ((16.0_ki)*(t15+t17-(t9+t8)))
      t8 = t22*t2*spbk3k1
      t9 = t22*t1*spak2k4*spbk4k1
      t15 = t22*t16*spbk3k1
      t17 = t22*t5*spak2k4*spbk4k1
      t18 = t22*t19*spbk3k1
      t20 = t22*t7*spak2k4*spbk4k1
      abb4n9 = ((8.0_ki)*(t18/t12+t20/t12+t15/t13+t17/t13-(t9/t3+t8/t3+t9/t12+t8&
      &/t12)))
      abb4n10 = ((8.0_ki)*(t18/t11+t20/t11+t15/t4+t17/t4-(t9/t14+t8/t14+t9/t11+t&
      &8/t11)))
      t6 = t22*t6
      t8 = t22*t5*spak3k4*spbk4k1
      t9 = t22*t10
      abb4n11 = ((4.0_ki)*(t6/t12+t6/t3-(t8/t13+t9/t12)))
      abb4n12 = ((4.0_ki)*(t6/t11+t6/t14-(t8/t4+t9/t11)))
      t1 = t22*t1*spak1k2*spbk4k1
      t2 = t22*t2*spbk4k3
      t5 = t22*t5*spak1k2*spbk4k1
      t6 = t22*t16*spbk4k3
      t7 = t22*t7*spak1k2*spbk4k1
      t8 = t22*t19*spbk4k3
      abb4n13 = ((8.0_ki)*(t7/t12+t8/t12+t5/t13+t6/t13-(t2/t3+t2/t12+t1/t3+t1/t1&
      &2)))
      abb4n14 = ((8.0_ki)*(t7/t11+t8/t11+t5/t4+t6/t4-(t2/t14+t2/t11+t1/t14+t1/t1&
      &1)))
      rat2d4 = 0
      rat2 = rat2 + rat2d4
      abb4n16 = abb4n1
      abb4n17 = abb4n14
      abb4n18 = abb4n13
      abb4n19 = abb4n12
      abb4n20 = abb4n11
      abb4n21 = abb4n10
      abb4n22 = abb4n9
      abb4n23 = abb4n8
      abb4n24 = abb4n7
      abb4n25 = abb4n6
      abb4n26 = abb4n5
      abb4n27 = abb4n4
      abb4n28 = abb4n3
      abb4n29 = abb4n2
   end subroutine
end module p0_dubar_emnebarbbbar_abbrevd4h3
