module     p0_dubar_emnebarbbbar_d25h3l1d
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/Wmbb/1.4/Virtual/p0
   ! _dubar_emnebarbbbar/helicity3/d25h3l1d.f90
   ! generator: haggies (1.1)
   use p0_dubar_emnebarbbbar_config, only: ki
   use p0_dubar_emnebarbbbar_util, only: cond, d => metric_tensor
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   integer, private :: iv0
   integer, private :: iv1
   integer, private :: iv2
   integer, private :: iv3
   real(ki), dimension(4), private :: qshift


   public :: derivative, reconstruct_d25
contains

!---#[ function derivative:
   function derivative(mu2, i1, i2, i3) result(numerator)
      use p0_dubar_emnebarbbbar_globalsl1, only: epspow
      use p0_dubar_emnebarbbbar_kinematics
      use p0_dubar_emnebarbbbar_abbrevd25h3
      implicit none
      complex(ki), intent(in) :: mu2
      integer, intent(in), optional :: i1
      integer, intent(in), optional :: i2
      integer, intent(in), optional :: i3
      complex(ki) :: numerator
      complex(ki) :: loc
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14
      complex(ki) :: t15
      complex(ki) :: t16
      complex(ki) :: t17
      complex(ki) :: t18
      complex(ki) :: t19
      real(ki) :: t20
      real(ki) :: t21
      real(ki) :: t22
      integer :: deg
      complex(ki), dimension(4), parameter :: Q = (/&
        &(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki)/)
      qshift = k5
      numerator = 0.0_ki
      deg = 0
      if(present(i1)) then
         iv1 = i1
         deg = 1
      else
         iv1 = 1
      end if
      if(present(i2)) then
         iv2 = i2
         deg = 2
      else
         iv2 = 1
      end if
      if(present(i3)) then
         iv3 = i3
         deg = 3
      else
         iv3 = 1
      end if
      t1 = (spvak2k1(1)*qshift(1)-spvak2k1(2)*qshift(2)-spvak2k1(3)*qshift(3)-sp&
      &vak2k1(4)*qshift(4))
      t20 = dotproduct(qshift, qshift)
      t21 = dotproduct(k1, qshift)
      t22 = dotproduct(l6, qshift)
      t2 = (spvak3k4(1)*qshift(1)-spvak3k4(2)*qshift(2)-spvak3k4(3)*qshift(3)-sp&
      &vak3k4(4)*qshift(4))
      t3 = (spvak2l6(1)*qshift(1)-spvak2l6(2)*qshift(2)-spvak2l6(3)*qshift(3)-sp&
      &vak2l6(4)*qshift(4))
      t4 = (spvak2k4(1)*qshift(1)-spvak2k4(2)*qshift(2)-spvak2k4(3)*qshift(3)-sp&
      &vak2k4(4)*qshift(4))
      t5 = (spvak2l5(1)*qshift(1)-spvak2l5(2)*qshift(2)-spvak2l5(3)*qshift(3)-sp&
      &vak2l5(4)*qshift(4))
      if(deg.eq.0) then
         numerator = (abb25n19+t1*abb25n49+t1*t1*abb25n28+t2*abb25n41+t20*abb25n&
         &33+t21*abb25n37+t22*abb25n39+t3*abb25n42+abb25n40*dotproduct(k2, qshif&
         &t)+t1*t2*abb25n22+t1*t20*abb25n46+t1*t21*abb25n25+t1*t22*abb25n27+t1*t&
         &3*abb25n21+t1*t4*abb25n23+t2*t3*abb25n35+t1*t2*t5*abb25n53)
         return
      end if
      t6 = k1(iv1)
      t7 = l6(iv1)
      t8 = qshift(iv1)
      t9 = spvak2k1(iv1)
      t10 = spvak2l6(iv1)
      t11 = spvak3k4(iv1)
      t12 = spvak2k4(iv1)
      t13 = spvak2l5(iv1)
      if(deg.eq.1) then
         numerator = (k2(iv1)*abb25n31+t10*abb25n29+t11*abb25n30+t6*abb25n34+t7*&
         &abb25n32+t8*abb25n38+t9*abb25n24+t1*t10*abb25n52+t1*t11*abb25n51+t1*t1&
         &2*abb25n50+t1*t6*abb25n48+t1*t7*abb25n44+t1*t8*abb25n45+t1*t9*abb25n43&
         &+t10*t2*abb25n36+t11*t3*abb25n36+t2*t9*abb25n51+t20*t9*abb25n26+t21*t9&
         &*abb25n48+t22*t9*abb25n44+t3*t9*abb25n52+t4*t9*abb25n50+t1*t11*t5*abb2&
         &5n20+t1*t13*t2*abb25n20+t2*t5*t9*abb25n20)
         return
      end if
      t20 = d(iv1,iv2)
      t3 = spvak2k1(iv2)
      t4 = spvak2l6(iv2)
      t14 = spvak3k4(iv2)
      t15 = t14*t9
      t16 = t11*t3
      t17 = spvak2l5(iv2)
      t18 = t17*t9
      t19 = t13*t3
      if(deg.eq.2) then
         numerator = ((2.0_ki)*(t20*abb25n33+t1*t20*abb25n46+t3*t9*abb25n28)+t15&
         &*abb25n22+t16*abb25n22+k1(iv2)*t9*abb25n25+l6(iv2)*t9*abb25n27+qshift(&
         &iv2)*t9*abb25n47+spvak2k4(iv2)*t9*abb25n23+t10*t14*abb25n35+t10*t3*abb&
         &25n21+t11*t4*abb25n35+t12*t3*abb25n23+t15*t5*abb25n53+t16*t5*abb25n53+&
         &t18*t2*abb25n53+t19*t2*abb25n53+t3*t6*abb25n25+t3*t7*abb25n27+t3*t8*ab&
         &b25n47+t4*t9*abb25n21+t1*t11*t17*abb25n53+t1*t13*t14*abb25n53)
         return
      end if
      t1 = spvak2k1(iv3)
      t2 = spvak3k4(iv3)
      t4 = spvak2l5(iv3)
      if(deg.eq.3) then
         numerator = ((2.0_ki)*(d(iv1,iv3)*t3*abb25n26+d(iv2,iv3)*t9*abb25n26+t1&
         &*t20*abb25n26)+t18*t2*abb25n20+t19*t2*abb25n20+t1*t11*t17*abb25n20+t1*&
         &t13*t14*abb25n20+t11*t3*t4*abb25n20+t14*t4*t9*abb25n20)
         return
      end if
   end function derivative
!---#] function derivative:
!---#[ subroutine reconstruct_d25:
   subroutine     reconstruct_d25(coeffs)
      use p0_dubar_emnebarbbbar_groups, only: tensrec_info_group4
      implicit none
      complex(ki), parameter :: czip = (0.0_ki, 0.0_ki)
      complex(ki), parameter :: cone = (1.0_ki, 0.0_ki)

      type(tensrec_info_group4), intent(out) :: coeffs
      ! rank 3 case:
      !---[# reconstruct coeffs%coeffs_25:
      coeffs%coeffs_25%c0 = derivative(czip)
      coeffs%coeffs_25%c1(1,1) = derivative(czip,1)
      coeffs%coeffs_25%c1(1,2) = derivative(czip,1,1) / 2.0_ki
      coeffs%coeffs_25%c1(1,3) = derivative(czip,1,1,1) / 6.0_ki
      coeffs%coeffs_25%c1(2,1) = -derivative(czip,2)
      coeffs%coeffs_25%c1(2,2) = derivative(czip,2,2) / 2.0_ki
      coeffs%coeffs_25%c1(2,3) = -derivative(czip,2,2,2) / 6.0_ki
      coeffs%coeffs_25%c1(3,1) = -derivative(czip,3)
      coeffs%coeffs_25%c1(3,2) = derivative(czip,3,3) / 2.0_ki
      coeffs%coeffs_25%c1(3,3) = -derivative(czip,3,3,3) / 6.0_ki
      coeffs%coeffs_25%c1(4,1) = -derivative(czip,4)
      coeffs%coeffs_25%c1(4,2) = derivative(czip,4,4) / 2.0_ki
      coeffs%coeffs_25%c1(4,3) = -derivative(czip,4,4,4) / 6.0_ki
      coeffs%coeffs_25%c2(1,1) = -derivative(czip,1,2)
      coeffs%coeffs_25%c2(1,2) = derivative(czip,1,2,2) / 2.0_ki
      coeffs%coeffs_25%c2(1,3) = -derivative(czip,1,1,2) / 2.0_ki
      coeffs%coeffs_25%c2(2,1) = -derivative(czip,1,3)
      coeffs%coeffs_25%c2(2,2) = derivative(czip,1,3,3) / 2.0_ki
      coeffs%coeffs_25%c2(2,3) = -derivative(czip,1,1,3) / 2.0_ki
      coeffs%coeffs_25%c2(3,1) = -derivative(czip,1,4)
      coeffs%coeffs_25%c2(3,2) = derivative(czip,1,4,4) / 2.0_ki
      coeffs%coeffs_25%c2(3,3) = -derivative(czip,1,1,4) / 2.0_ki
      coeffs%coeffs_25%c2(4,1) = derivative(czip,2,3)
      coeffs%coeffs_25%c2(4,2) = -derivative(czip,2,3,3) / 2.0_ki
      coeffs%coeffs_25%c2(4,3) = -derivative(czip,2,2,3) / 2.0_ki
      coeffs%coeffs_25%c2(5,1) = derivative(czip,2,4)
      coeffs%coeffs_25%c2(5,2) = -derivative(czip,2,4,4) / 2.0_ki
      coeffs%coeffs_25%c2(5,3) = -derivative(czip,2,2,4) / 2.0_ki
      coeffs%coeffs_25%c2(6,1) = derivative(czip,3,4)
      coeffs%coeffs_25%c2(6,2) = -derivative(czip,3,4,4) / 2.0_ki
      coeffs%coeffs_25%c2(6,3) = -derivative(czip,3,3,4) / 2.0_ki
      coeffs%coeffs_25%c3(1,1) = derivative(czip,1,2,3)
      coeffs%coeffs_25%c3(2,1) = derivative(czip,1,2,4)
      coeffs%coeffs_25%c3(3,1) = derivative(czip,1,3,4)
      coeffs%coeffs_25%c3(4,1) = -derivative(czip,2,3,4)
      !---#] reconstruct coeffs%coeffs_25:
   end subroutine reconstruct_d25
!---#] subroutine reconstruct_d25:
end module p0_dubar_emnebarbbbar_d25h3l1d
